// djrandom.js

djr = {};

// Global state.
djr.state = {
  userid: null
};

// Debugging.
djr.debug = function(msg) {
  $('#debug').append(msg + '<br>');
};


// History and state

djr.history = {
  cur_hash: null
};

// Save current state to hashtag.
djr.history.save = function() {
  var curPlaylist = djr.state.player.getCurrentPlaylistID();
  var hash_tag = '#pl:' + curPlaylist;
  djr.history.cur_hash = hash_tag;
  window.location.hash = hash_tag;
};

// Restore current state from hashtag.
djr.history.restore = function() {
  var hash_tag = window.location.hash;
  if (!hash_tag || hash_tag == '#' || hash_tag == djr.history.cur_hash) {
    return;
  }
  djr.history.cur_hash = hash_tag;

  var hash_info = {};
  $.each(hash_tag.substr(1).split(','), function(idx, value) {
    var kv = value.split(':');
    hash_info[kv[0]] = unescape(kv.slice(1).join(':'));
  });

  if (hash_info.pl) {
    var newPlaylistID = hash_info.pl;
    djr.state.player.loadPlaylist(newPlaylistID, function() {
      djr.loadPlaylistHtml();
    });
  }
};

djr.getQuery = function() {
  return $('#queryField').val();
};

djr.setQuery = function(query) {
  djr.debug('setQuery:' + query);
  $('#queryField').val(query);
  djr.doSearch(query);
};

djr.doSearch = function() {
  $('#loading').show();
  $.getJSON('/json/search', {'q': djr.getQuery()},
            function(data, status, jqxhr) {
                // Build an ordered array of unique hashes, which will be
              // our new playlist.
              var hashes = Array();
              $.each(data.results, function(idx, item) {
                if ($.inArray(item.sha1, hashes) < 0) {
                  hashes.push(item.sha1);
                }
              });

              // Clear the current playlist and save a new one.
              if (hashes.length > 0) {
                djr.state.player.loadSearchResults(hashes, false);
              }

              // Load the HTML rendering of the playlist.
              djr.loadPlaylistHtml();

              djr.history.save();
          });
};


// Initialization.
djr.init = function(userid) {
  djr.state.userid = userid;

  // Restore state if the URL changes.
  $(window).bind('hashchange', djr.history.restore);

  // Initialize the global Player instance.
  djr.state.player = new djr.Player('#djr_player');
};


// Puppa.
